<?php
/**
 * fishuv login system - trida uzivatele
 *
 * @author fish <fish@archa.cz>
 * @package flogin
 * @version 0.2
 *
 */
/**
 * trida pro praci s uzivatelem
 * @package flogin_user
 *
 */
class flogin_user {

  /**
   * variable $dbh
   * @protected object
   */
  protected $dbh=NULL;
  /**
   * variable $user_id
   * @protected object
   */
  public $id_user=NULL;
  /**
   * variable login_db
   * @public string schema s login tabulkama
   */
  public $login_db = NULL;
  protected $_login_db = NULL;

  /**
   * variable $id_grp
   * @public integer
   */
  public   $id_grp=NULL;
  private $_id_grp=NULL;
  /**
   * variable $name
   * @public string
   */
  public   $name=NULL;
  private $_name=NULL;
  /**
   * variable $fname
   * @public string
   */
  public   $fname=NULL;
  private $_fname=NULL;
  /**
   * variable $lname
   * @public string
   */
  public   $lname=NULL;
  private $_lname=NULL;
  /**
   * variable $tel
   * @public string
   */
  public   $tel=NULL;
  private $_tel=NULL;
  /**
   * variable $mobil
   * @public string
   */
  public   $mobil=NULL;
  private $_mobil=NULL;
  /**
   * variable $mail
   * @public string
   */
  public   $mail=NULL;
  private $_mail=NULL;
  /**
   * variable $address
   * @public string
   */
  public   $address=NULL;
  private $_address=NULL;
  /**
   * variable $city
   * @public string
   */
  public   $city=NULL;
  private $_city=NULL;
  /**
   * variable $zip
   * @public string
   */
  public   $zip=NULL;
  private $_zip=NULL;
  /**
   * variable $details
   * @public string
   */
  public   $details=NULL;
  private $_details=NULL;
  /**
   * variable $login
   * @public string
   */
  public   $login=NULL;
  private $_login=NULL;
  /**
   * variable $pwd
   * @public string
   */
  public   $pwd=NULL;
  private $_pwd=NULL;
  /**
   * variable $hash_pwd
   * @public string
   */
  private $_hash_pwd=NULL;
  /**
   * variable $val
   * @public array
   */
  public   $val=array();
  private $_val=array();
  /**
   * variable $groups
   * @private array
   */
  private $_groups = array();
  private $groups = array();
  /**
   * variable $id_conn
   * @public string
   */
  public  $id_conn=NULL;
  /**
   * variable $lastact
   * @public string
   */
  public  $lastact=NULL;
  /**
   * variable $status
   * @public string vysledek posledni operace
   */
  public  $status=NULL;
  /**
   * variable $DeleteRowOnEmptyVal
   * @static boolean pri nastaveni nektere pridavne hodnoty uzivatele na empty mazat radek z databaze, nebo jej ponechat a nastavit na tuto hodnotu
   */
  static $DeleteRowOnEmptyVal = true;
  /**
   * variable $useSha1
   * @public boolean heslo je ulozene jako SHA1
   */
  public $useSha1 = true;

  // {{{ setUserVal
  /**
   * nastaveni tridy uzivatele
   *
   * @param object $dbh handle databazoveho pripojeni
   * @param integer $user_id id uzivatele
   * @param string $class trida uzivatele
   * @param string $val hodnota k nastaveni
   * @optional @param string $login_db jmeno databaze, ve ktere jsou ulozeny uzivatele. Vychozi nastaveni NULL
   * @optional @param boolean $DeleteRowOnEmptyVal priznak, zda pri zadani empty hodnoty parametru $val smazat radek z db nebo jen nastavit na tuto hodnotu
   * @return mixed TRUE | PEAR_Error
   */
  static function setUserVal(&$dbh,$user_id,$class,$val,$login_db=NULL,$DeleteRowOnEmptyVal=false){
    $query ="SELECT id FROM ";
    if(!empty($login_db)){ $query.="`".$login_db."`."; }
    $query.="classes WHERE varname=".$dbh->quote(preg_replace("/^_/","",$class))." ";
    $cls_id=0;
    if(!PEAR::isError($res=$dbh->queryAll($query))){
      if(isset($res[0]["id"])){ $cls_id=$res[0]["id"]*1; }
    } else {
      return($res);
    }
    if($cls_id!=0){
      if ($DeleteRowOnEmptyVal && empty($val)) {
        $query = 'DELETE FROM ';
        if(!empty($login_db)){ $query.="`".$login_db."`."; }
        $query.="user_classes ";
        $query.="WHERE id_user=".$dbh->quote($user_id)." AND id_class=".$dbh->quote($cls_id)." ";
        if(!PEAR::isError($res=$dbh->query($query))){
          return(TRUE);
        } else {
          return($res);
        }
      } else {
        $query ="INSERT IGNORE INTO ";
        if(!empty($login_db)){ $query.="`".$login_db."`."; }
        $query.="user_classes(id_user,id_system,id_class,val) ";
        $query.="VALUES(".$dbh->quote($user_id).",0,".$dbh->quote($cls_id).",".$dbh->quote($val).") ";
        if(!PEAR::isError($res=$dbh->query($query))){
          $query ="UPDATE ";
          if(!empty($login_db)){ $query.="`".$login_db."`."; }
          $query.="user_classes SET val=".$dbh->quote($val)." ";
          $query.="WHERE id_user=".$dbh->quote($user_id)." AND id_class=".$dbh->quote($cls_id)." ";
          if(!PEAR::isError($res=$dbh->query($query))){
            return(TRUE);
          } else {
            return($res);
          }
        } else {
          return($res);
        }
      }
    } else {
      return(PEAR::throwError("Neexistujici trida uzivatele: ".$class));
    }
  }
  // }}} setUserVal

  // {{{ getUserVal
  /**
   * zjisteni tridy uzivatele
   *
   * @param object $dbh handle databazoveho pripojeni
   * @param integer $user_id id uzivatele
   * @param string $class trida uzivatele
   * @return string NULL | hodnota tridy
   */
  static function getUserVal(&$dbh,$user_id,$class,$login_db=NULL){
    $query ="SELECT val FROM (";
    if(!empty($login_db)){ $query.="`".$login_db."`."; }
    $query.="classes, ";
    if(!empty($login_db)){ $query.="`".$login_db."`."; }
    $query.="user_classes) ";
    $query.="WHERE classes.varname=".$dbh->quote(preg_replace("/^_/","",$class))." ";
    $query.="AND user_classes.id_class=classes.id AND user_classes.id_user=".$dbh->quote($user_id,"integer")." ";
//    echo $query._nl;
    $retval=NULL;
    if(!PEAR::isError($res=$dbh->queryAll($query))){
      if(isset($res[0]["val"])){ $retval=$res[0]["val"]; }
    }
    return($retval);
  }
  // }}} getUserVal


  // {{{ constructor
  /**
   * Constructor
   *
   * @param object $dbh handle databazoveho pripojeni
   * @param integer $user_id volitelne, id uzivatele
   * @return object flogin_user objekt uzivatele
   */
  function __construct($dbh, $user_id = NULL){
    $this->setDBH($dbh);
    if(isset($user_id)){
      $Status = $this->load($user_id);
      if (PEAR::isError($Status)) {
        throw new Exception($Status->getMessage(), $Status->getCode());
      } elseif (false === $Status) {
        // uzivatel nenalezen
        // @todo:
      }
    }
  }
  // }}} constructor


  // {{{ setDBH
  /**
   * nastavi handle databaze
   *
   * @param object $dbh
   * @return void
   */
  function setDBH($dbh){
    $this->dbh=$dbh;
  }
  // }}} setDBH


  // {{{ load
  /**
   * nacte uzivatele podle ID
   *
   * @param integer $user_id ID uzivatele
   * @return mixed TRUE nebo PEAR_Error
   */
  function load($user_id){
//    $this->id_user=$user_id;
    $query ="SELECT * FROM ";
    if(!empty($this->login_db)){ $query.="`".$this->login_db."`."; }
    $query.="users ";
    $query.="WHERE id_user=".$this->dbh->quote($user_id,"integer")." ";
    $query.="LIMIT 0,1 ";
    $res=$this->dbh->query($query);
    if(PEAR::isError($res)){
      return(PEAR::throwError("User error: ".__LINE__.": ".$res->getMessage()."; ".$res->getUserInfo()));
    } else {
      if($row=$res->fetchRow()){
        $this->id_user=$row["id_user"];
        $this->_id_user=$row["id_user"];
        $this->id_grp=$row["id_grp"];
        $this->_id_grp=$row["id_grp"];
        $this->name=$row["name"];
        $this->_name=$row["name"];
        $this->fname=$row["fname"];
        $this->_fname=$row["fname"];
        $this->lname=$row["lname"];
        $this->_lname=$row["lname"];
        $this->tel=$row["tel"];
        $this->_tel=$row["tel"];
        $this->mobil=$row["mobil"];
        $this->_mobil=$row["mobil"];
        $this->mail=$row["mail"];
        $this->_mail=$row["mail"];
        $this->address=$row["address"];
        $this->_address=$row["address"];
        $this->city=$row["city"];
        $this->_city=$row["city"];
        $this->zip=$row["zip"];
        $this->details=$row["details"];
        $this->_zip=$row["zip"];
        $this->_details=$row["details"];
        $this->login=$row["login"];
        $this->_login=$row["login"];
        $this->_hash_pwd=$row["hash_pwd"];
        $this->id_conn=$row["id_conn"];
        $this->lastact=$row["lastact"];

        $this->val=array();
        $this->_val=array();
        $query ="SELECT classes.varname AS cname,user_classes.val AS cval FROM (";
        if(!empty($this->login_db)){ $query.="`".$this->login_db."`."; }
        $query.="classes,";
        if(!empty($this->login_db)){ $query.="`".$this->login_db."`."; }
        $query.="user_classes) ";
        $query.="WHERE user_classes.id_class=classes.id ";
        $query.="AND user_classes.id_user=".$this->dbh->quote($this->id_user,"integer")." ";
        $res2=$this->dbh->query($query);
        if(PEAR::isError($res2)){
          return(PEAR::throwError("User error: ".__LINE__.": ".$res2->getMessage()."; ".$res2->getUserInfo()));
        } else {
          while($row2=$res2->fetchRow()){
            $this->val["_".$row2["cname"]]=$row2["cval"];
            $this->_val["_".$row2["cname"]]=$row2["cval"];
          }
        }
        $this->_groups = array($this->_id_grp);
        $query='SELECT id_grp FROM ';
        if(!empty($this->login_db)){ $query.="`".$this->login_db."`."; }
        $query.='user_groups WHERE id_user='.$this->dbh->quote($this->id_user,"integer");
        if (PEAR::isError($Groups=$this->dbh->query($query))) {
          return(PEAR::throwError("User error: ".__LINE__.": ".$res2->getMessage()."; ".$res2->getUserInfo()));
        } else {
          while($Row = $Groups->fetchRow()) {
            if (!in_array($Row['id_grp'],$this->_groups)) {
              $this->_groups[]=$Row['id_grp'];
            }
          }
        }
        $this->groups = $this->_groups;
        return true;
      } else {
        return false;
      }
    }
  }
  // }}} load

  // {{{ save
  /**
   * ulozi uzivatele podle ID nebo vytvori novyho, pokud ID neni nastaveny
   *
   * @param boolean $as_new zalozit jako novyho uzivatele, i kdyz je nastaveny ID (tj. kdyz chci duplikovat nejakyho uzivatele)
   * @return mixed TRUE nebo PEAR_Error
   */
  function save($as_new=FALSE){
    $this->status=NULL;
    if(!isset($this->login) || $this->login==""){
      $this->status="Chybí login";
      return(FALSE);
    }
    if(!isset($this->mail) || $this->mail==""){
      $this->status="Chybí e-mail";
      return(FALSE);
    }
    if(isset($this->login) && $this->login!="" && (!isset($this->_login) || $this->login!=$this->_login || $as_new)){
      $query ="SELECT COUNT(id_user) AS pocet FROM ";
      if(!empty($this->login_db)){ $query.="`".$this->login_db."`."; }
      $query.="users WHERE login=".$this->dbh->quote($this->login)." ";
      $lcount=0;
      $res=$this->dbh->query($query);
      if(!PEAR::isError($res)){
        if($row=$res->fetchRow()){
          $lcount=$row["pocet"];
        }
      }
      if($lcount>0){
        $LoginName=_("login");
        if($this->mail==$this->login){
          $LoginName=_("e-mail");
        }
        $this->status=sprintf(_("Tento %s byl již pro registraci použit. Zadejte prosím jiný."),$LoginName);
        return(FALSE);
      }
    }
//    pre_print($this);
    if(!isset($this->id_user) || $as_new){
      if(!isset($this->pwd) || $this->pwd==""){
        $this->status="Chybí heslo";
        return(FALSE);
      }
      $query ="INSERT INTO ";
      if(!empty($this->login_db)){ $query.="`".$this->login_db."`."; }
      $query.="users(";
      if(isset($this->id_grp)){ $query.="`id_grp`,"; }
      if(isset($this->name)){ $query.="`name`,"; }
      if(isset($this->fname)){ $query.="`fname`,"; }
      if(isset($this->lname)){ $query.="`lname`,"; }
      if(isset($this->tel)){ $query.="`tel`,"; }
      if(isset($this->mobil)){ $query.="`mobil`,"; }
      if(isset($this->mail)){ $query.="`mail`,"; }
      if(isset($this->address)){ $query.="`address`,"; }
      if(isset($this->city)){ $query.="`city`,"; }
      if(isset($this->zip)){ $query.="`zip`,"; }
      if(isset($this->details)){ $query.="`details`,"; }
      if(isset($this->login)){ $query.="`login`,"; }
      if(isset($this->pwd) && $this->pwd!=""){ $query.="`hash_pwd`"; }
      $query.=") ";
      $query.="VALUES(";
      if(isset($this->id_grp)){ $query.=$this->dbh->quote($this->id_grp).","; }
      if(isset($this->name)){ $query.=$this->dbh->quote($this->name).","; }
      if(isset($this->fname)){ $query.=$this->dbh->quote($this->fname).","; }
      if(isset($this->lname)){ $query.=$this->dbh->quote($this->lname).","; }
      if(isset($this->tel)){ $query.=$this->dbh->quote($this->tel).","; }
      if(isset($this->mobil)){ $query.=$this->dbh->quote($this->mobil).","; }
      if(isset($this->mail)){ $query.=$this->dbh->quote($this->mail).","; }
      if(isset($this->address)){ $query.=$this->dbh->quote($this->address).","; }
      if(isset($this->city)){ $query.=$this->dbh->quote($this->city).","; }
      if(isset($this->zip)){ $query.=$this->dbh->quote($this->zip).","; }
      if(isset($this->details)){ $query.=$this->dbh->quote($this->details).","; }
      if(isset($this->login)){ $query.=$this->dbh->quote($this->login).","; }
      if(isset($this->pwd)){
        // $query.=$this->dbh->quote($this->useSha1?sha1($this->pwd):md5($this->pwd))."";
        $query.= $this->dbh->quote(flogin::createHash($this->pwd))."";
      }
      $query.=") ";
//      echo $query._nl;
      $res=$this->dbh->query($query);
      if(PEAR::isError($res)){
        $this->status="User error: ".__LINE__.": ".$res->getMessage()."; ".$res->getUserInfo();
        return(FALSE);
      }
      $this->id_user=$this->dbh->lastInsertID();
      $this->_id_user=$this->dbh->lastInsertID();
    } else {
      $changes=array();
      if(isset($this->id_grp) && (!isset($this->_id_grp) || $this->id_grp!=$this->_id_grp)){ $changes[]="`id_grp`=".$this->dbh->quote($this->id_grp); }
      if(isset($this->name) && (!isset($this->_name) || $this->name!=$this->_name)){ $changes[]="`name`=".$this->dbh->quote($this->name); }
      if(isset($this->fname) && (!isset($this->_fname) || $this->fname!=$this->_fname)){ $changes[]="`fname`=".$this->dbh->quote($this->fname); }
      if(isset($this->lname) && (!isset($this->_lname) || $this->lname!=$this->_lname)){ $changes[]="`lname`=".$this->dbh->quote($this->lname); }
      if(isset($this->tel) && (!isset($this->_tel) || $this->tel!=$this->_tel)){ $changes[]="`tel`=".$this->dbh->quote($this->tel); }
      if(isset($this->mobil) && (!isset($this->_mobil) || $this->mobil!=$this->_mobil)){ $changes[]="`mobil`=".$this->dbh->quote($this->mobil); }
      if(isset($this->mail) && (!isset($this->_mail) || $this->mail!=$this->_mail)){ $changes[]="`mail`=".$this->dbh->quote($this->mail); }
      if(isset($this->address) && (!isset($this->_address) || $this->address!=$this->_address)){ $changes[]="`address`=".$this->dbh->quote($this->address); }
      if(isset($this->city) && (!isset($this->_city) || $this->city!=$this->_city)){ $changes[]="`city`=".$this->dbh->quote($this->city); }
      if(isset($this->zip) && (!isset($this->_zip) || $this->zip!=$this->_zip)){ $changes[]="`zip`=".$this->dbh->quote($this->zip); }
      if(isset($this->details) && (!isset($this->_details) || $this->details!=$this->_details)){ $changes[]="`details`=".$this->dbh->quote($this->details); }
      if(isset($this->login) && (!isset($this->_login) || $this->login!=$this->_login)){ $changes[]="`login`=".$this->dbh->quote($this->login); }
      if(isset($this->pwd) && $this->pwd!="" && (!isset($this->_pwd) || $this->pwd!=$this->_pwd)){
        // $changes[]="`hash_pwd`=".$this->dbh->quote($this->useSha1?sha1($this->pwd):md5($this->pwd));
        $changes[] = "`hash_pwd` = ".$this->dbh->quote(flogin::createHash($this->pwd));
      }
      if(count($changes)){
        $query ="UPDATE ";
        if(!empty($this->login_db)){ $query.="`".$this->login_db."`."; }
        $query.="users SET ";
        $query.=implode(",",$changes)." ";
        $query.="WHERE id_user=".$this->dbh->quote($this->id_user)." ";
        $query.="LIMIT 1 ";
//        echo $query._nl;
        $res=$this->dbh->query($query);
        if(PEAR::isError($res)){
          $this->status="User error: ".__LINE__.": ".$res->getMessage()."; ".$res->getUserInfo();
          return(FALSE);
        }
      }
    }
    foreach($this->val as $var=>$val){
      if(!isset($this->_val[$var]) || $this->val[$var]!=$this->_val[$var] || $as_new){
//        echo $var."=>".$val._nl;
        $res=self::setUserVal($this->dbh,$this->id_user,$var,$val,$this->login_db,self::$DeleteRowOnEmptyVal);
        if(PEAR::isError($res)){
          $this->status="User error: ".__LINE__.": ".$res->getMessage()."; ".$res->getUserInfo();
          return(FALSE);
        }
      }
    }
    return(TRUE);
  }
  // }}} save
  // {{{ getUserGroups
  /**
   * @return array of int - idcka grup, kterych je clenem
   */
  function getUserGroups() {
    return $this->groups;
  }
  // }}} getUserGroups

  // {{{ addUserIntoGroup
  /**
   * @param $NewGroupId - int: id groupy, do ktere uzivatele pridat
   */
  function addUserIntoGroup($NewGroupId) {
    if (empty($this->groups)) {
      // nemel zatim zadnou grupu
      $this->groups[]=$NewGroupId;
      $this->id_grp = $NewGroupId;
    } elseif (!in_array($NewGroupId, $this->groups)) {
      $this->groups[]=$NewGroupId;
    }
    return true;
  }
  // }}} addUserIntoGroup

  // {{{ removeUserFromGroup
  /**
   * @param $RemoveGroupId - int: id groupy, ze ktere uzivatele vyradit
   */
  function removeUserFromGroup($RemoveGroupId) {
    $Pos = array_search($RemoveGroupId, $this->groups);
    if ($Pos !== false) {
      unset($this->groups[$Pos]);
    }
    //krome toho je treba jeste pripadne zmenit hlavni skupinu uzivatele
    if ($this->id_grp == $RemoveGroupId) {
      if (empty($this->groups)) {
        $this->id_grp = 0;
      } else {
        $Groups = $this->groups;
        reset($Groups);
        $this->id_grp = current($Groups);
      }
    }
    return true;
  }
  // }}} removeUserFromGroup

  // {{{ setUserMainGroup
  /**
   * @param $NewMainGroup - int: id nove hlavni grupy
   *
   * @return boolean - true on success, false on fail (user is not member of $NewMainGroup, use addUserIntoGroup first)
   */
  function setUserMainGroup($NewMainGroup) {
    if (in_array($NewMainGroup, $this->groups)) {
      $this->id_grp = $NewMainGroup;
      return true;
    } else {
      return false;
    }
  }
  // }}} setUserMainGroup

  // {{{ saveGroups
  /**
   * funkce aktualizuje ulozene skupiny v databazi dle nastavevni promennych v tomto objeku
   */
  protected function saveGroups() {

    $OldGroups = $this->_groups;
    $Pos = array_search($this->_id_grp, $OldGroups);
    if ($Pos !== false) {
      unset($OldGroups[$Pos]);
    }
    sort($OldGroups);
    $NewGroups = $this->groups;
    $Pos = array_search($this->id_grp, $NewGroups);
    if ($Pos !== false) {
      unset($NewGroups[$Pos]);
    }
    sort($NewGroups);
    if ($NewGroups == $OldGroups) {
      return true;
    }

    // takze tam mame nejakou zmenu
    $Add = array();
    foreach($NewGroups as $Key => $GroupId) {
      $Pos = array_search($GroupId, $OldGroups);
      if ($Pos !== false) {
        // je ve starem i novem
        unset($OldGroups[$Pos]);
      } else {
        // je v novem, ale neni ve starem
        $Add[] = $GroupId;
      }
    }
    if (!empty($Add)) {
      $query = 'INSERT INTO ';
      if(!empty($this->login_db)){ $query.="`".$this->login_db."`."; }
      $query.='`user_groups` (`id_user`, `id_grp`) VALUES ';
      $Insert = array();
      foreach ($Add as $GroupId) {
        $Insert[] = '('.$this->dbh->quote($this->id_user,'integer').', '.$this->dbh->quote($GroupId,'integer').')';
      }
      $query .= implode(', ', $Insert);
      $res = $this->dbh->query($query);
      if(PEAR::isError($res)){
        $this->status="User error: ".__LINE__.": ".$res->getMessage()."; ".$res->getUserInfo();
        return(FALSE);
      }
    }
    if (!empty($OldGroups)) {
      // zbyla tam nejaka skupina, ktera ted neni v novych skupinach
      $query = 'DELETE FROM ';
      if(!empty($this->login_db)){ $query.="`".$this->login_db."`."; }
      $query.='`user_groups` WHERE ';
      $Delete = array();
      foreach ($OldGroups as $GroupId) {
        $Delete[] = '(`id_user` = '.$this->dbh->quote($this->id_user,'integer').' AND `id_grp`='.$this->dbh->quote($GroupId,'integer').')';
      }
      $query .= implode(' OR ', $Delete);
      $res=$this->dbh->query($query);
      if(PEAR::isError($res)){
        $this->status="User error: ".__LINE__.": ".$res->getMessage()."; ".$res->getUserInfo();
        return(FALSE);
      }
    }
    if ($this->id_grp != $this->_id_grp) {
      // zmena hlavni grupy
      $query = 'UPDATE ';
      if(!empty($this->login_db)){ $query.="`".$this->login_db."`."; }
      $query.= '`users` SET `id_grp`='.$this->dbh->quote($this->id_grp, 'integer').' WHERE `id_user`='.$this->dbh->quote($this->id_user);
      $res=$this->dbh->query($query);
      if(PEAR::isError($res)){
        $this->status="User error: ".__LINE__.": ".$res->getMessage()."; ".$res->getUserInfo();
        return(FALSE);
      }
    }
    // all ok
    $this->_groups = $this->groups;
    $this->_id_grp = $this->id_grp;
    return true;
  }
  // }}} saveGroups
  
  // {{{ isUserAdmin
  /**
   *
   * @return array seznam skupin ve kterych je uzivatel admin, clen skupiny 1 je automaticky admin.
   */
  function isUserAdmin() {
    // seznam skupin ve kterych je uzivatel admin
    $query = "SELECT id_grp FROM ";
    if(!empty($this->login_db)){ $query.="`".$this->login_db."`."; }
    $query.= "group_admins ";
    $query.= "WHERE id_user=".$this->dbh->quote($this->id_user)." ";
    if(PEAR::isError($adminGroups=$this->dbh->getAll($query))){
      $adminGroups=array();
    }
    
    // pokud je uzivatel ve skupine 1, je admin
    if($this->id_grp==1){
      $adminGroups=array_merge($adminGroups,array(1));
    }
    return($adminGroups);
  }
  // }}} isUserAdmin
  
  function getPwd() {
    // vrati hash aktualniho hesla
    return($this->_hash_pwd);
  }
  

  /*

   */

}
?>
